<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CruiseComponent ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CruiseComponent extends AbstractStructArrayBase
{
    /**
     * The Component
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CruiseComponent[]
     */
    public $Component;
    /**
     * Constructor method for ArrayOfJP_CruiseComponent
     * @uses ArrayOfJP_CruiseComponent::setComponent()
     * @param \StructType\JP_CruiseComponent[] $component
     */
    public function __construct(array $component = array())
    {
        $this
            ->setComponent($component);
    }
    /**
     * Get Component value
     * @return \StructType\JP_CruiseComponent[]|null
     */
    public function getComponent()
    {
        return $this->Component;
    }
    /**
     * This method is responsible for validating the values passed to the setComponent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setComponent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateComponentForArrayConstraintsFromSetComponent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_CruiseComponentComponentItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CruiseComponentComponentItem instanceof \StructType\JP_CruiseComponent) {
                $invalidValues[] = is_object($arrayOfJP_CruiseComponentComponentItem) ? get_class($arrayOfJP_CruiseComponentComponentItem) : sprintf('%s(%s)', gettype($arrayOfJP_CruiseComponentComponentItem), var_export($arrayOfJP_CruiseComponentComponentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Component property can only contain items of type \StructType\JP_CruiseComponent, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Component value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseComponent[] $component
     * @return \ArrayType\ArrayOfJP_CruiseComponent
     */
    public function setComponent(array $component = array())
    {
        // validation for constraint: array
        if ('' !== ($componentArrayErrorMessage = self::validateComponentForArrayConstraintsFromSetComponent($component))) {
            throw new \InvalidArgumentException($componentArrayErrorMessage, __LINE__);
        }
        $this->Component = $component;
        return $this;
    }
    /**
     * Add item to Component value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseComponent $item
     * @return \ArrayType\ArrayOfJP_CruiseComponent
     */
    public function addToComponent(\StructType\JP_CruiseComponent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CruiseComponent) {
            throw new \InvalidArgumentException(sprintf('The Component property can only contain items of type \StructType\JP_CruiseComponent, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Component[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CruiseComponent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CruiseComponent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CruiseComponent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CruiseComponent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CruiseComponent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Component
     */
    public function getAttributeName()
    {
        return 'Component';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_CruiseComponent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
